<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_software_version".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnSoftwareVersion".
 *
 * Columns in table "cpn_software_version" available as properties of the model,
 * followed by relations of table "cpn_software_version" available as properties of the model.
 *
 * @property integer $id
 * @property string $guid
 * @property integer $cpn_software_id
 * @property integer $cpn_software_installation_id
 * @property integer $major
 * @property integer $minor
 * @property integer $build
 * @property integer $enabled_flag
 * @property integer $del_flag
 * @property string $date_to_release
 * @property string $payload_path
 * @property string $checksum
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property Account $addedByAccount
 * @property CpnSoftware $cpnSoftware
 * @property CpnSoftwareVersionLog[] $cpnSoftwareVersionLogs
 */
abstract class BaseCpnSoftwareVersion extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_software_version';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnSoftwareVersion|CpnSoftwareVersions', $n);
    }

    public static function representingColumn()
    {
        return 'guid';
    }

    public function rules()
    {
        return array(
            array('guid, cpn_software_id, checksum, added_by_account_id', 'required'),
            array('cpn_software_id, cpn_software_installation_id, major, minor, build, enabled_flag, del_flag, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('guid, payload_path', 'length', 'max' => 255),
            array('checksum', 'length', 'max' => 100),
            array('date_to_release, date_added, date_updated', 'safe'),
            array('cpn_software_installation_id, major, minor, build, enabled_flag, del_flag, date_to_release, payload_path, date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, guid, cpn_software_id, cpn_software_installation_id, major, minor, build, enabled_flag, del_flag, date_to_release, payload_path, checksum, date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnSoftware' => array(self::BELONGS_TO, 'CpnSoftware', 'cpn_software_id'),
            'cpnSoftwareVersionLogs' => array(self::HAS_MANY, 'CpnSoftwareVersionLog', 'cpn_software_version_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'guid' => Yii::t('app', 'Guid'),
            'cpn_software_id' => null,
            'cpn_software_installation_id' => Yii::t('app', 'Cpn Software Installation'),
            'major' => Yii::t('app', 'Major'),
            'minor' => Yii::t('app', 'Minor'),
            'build' => Yii::t('app', 'Build'),
            'enabled_flag' => Yii::t('app', 'Enabled Flag'),
            'del_flag' => Yii::t('app', 'Del Flag'),
            'date_to_release' => Yii::t('app', 'Date To Release'),
            'payload_path' => Yii::t('app', 'Payload Path'),
            'checksum' => Yii::t('app', 'Checksum'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'addedByAccount' => null,
            'cpnSoftware' => null,
            'cpnSoftwareVersionLogs' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('cpn_software_id', $this->cpn_software_id);
        $criteria->compare('cpn_software_installation_id', $this->cpn_software_installation_id);
        $criteria->compare('major', $this->major);
        $criteria->compare('minor', $this->minor);
        $criteria->compare('build', $this->build);
        $criteria->compare('enabled_flag', $this->enabled_flag);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('date_to_release', $this->date_to_release, true);
        $criteria->compare('payload_path', $this->payload_path, true);
        $criteria->compare('checksum', $this->checksum, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
